#include "mqtt.h"
#include "gps.h"
time_t gStart;


int gPwmCount = 0;  // 计数
int gmessage_type=10086;
int rc=0;
struct mosquitto *mosq;


unsigned char gmodeTemp=0;
unsigned char gtypeTemp=0;
unsigned char gpinTemp=0;
unsigned char gvalTemp=0;
unsigned char gvalt[4];


void on_connect(struct mosquitto *mosq, void *obj, int rc) //回调函数
{
    if (rc == 0) 
    {
     printf("Connected to broker\n");
     mosquitto_subscribe(mosq, NULL, TOPIC, 0);
     time_t start=time(NULL);
    }   
    else 
    {
    fprintf(stderr, "Connection failed with code %d\n", rc);
    }
}


int mqtt_init()
{
 // 初始化 mosquitto 库
    mosquitto_lib_init();  
    mosq = mosquitto_new(CLIENT_ID, true, NULL);
    if (!mosq) {
        fprintf(stderr, "Failed to create Mosquitto client\n");
        return -1;
    }
    mosquitto_int_option(mosq, MOSQ_OPT_PROTOCOL_VERSION, MQTT_PROTOCOL_V5);
    
}

//int init_mqtt(struct mosquitto *mosq)



void mqtt_wirte()
{
    
    int message=1;
    cJSON *root = cJSON_CreateObject();
    cJSON *body = cJSON_CreateObject();
    cJSON *head = cJSON_CreateObject();
    cJSON_AddStringToObject(body, "ip", ip_address);
    cJSON_AddStringToObject(body, "ID", TOPIC);
    cJSON_AddStringToObject(body, "N", glat);
    cJSON_AddStringToObject(body, "E", glon);
    if(gmessage_type==0)
    {
        message=0;
    }else{
        message=1;
    }
    cJSON_AddNumberToObject(head, "message_type",message);
    cJSON_AddItemToObject(root, "body", body);
    cJSON_AddItemToObject(root, "head",head);

    char *payload = cJSON_PrintUnformatted(root);
    
    printf("%s\n",payload);
    mosquitto_publish(mosq, NULL, TOPIC, strlen(payload), payload, 0, false); 
    
      
}




void message_0()//message_type为0时候要改变的值
{
    for(int i=1;i<=4;i++)
    {
        gPwmCount = 0;
        switch(i)
        {
            case 1:
                gvalt[0]= gtypeTemp;
                gvalt[1]=1;
                gvalt[2]=0;
                printf("gtypeTemp:%d\n",gvalt[0]); 
                printf("gmodeTemp:%d\n",gvalt[1]);
                printf("gvalTemp:%d\n",gvalt[2]);
                serial_Write(gvalt);
                break;
            case 2:
                gvalt[0]= gtypeTemp;
                gvalt[1]=2;
                gvalt[2]=0;
                printf("gtypeTemp:%d\n",gvalt[0]); 
                printf("gmodeTemp:%d\n",gvalt[1]);
                printf("gvalTemp:%d\n",gvalt[2]);
                serial_Write(gvalt);
                break;
            case 3:
                gvalt[0]= gtypeTemp;
                gvalt[1]=3;
                gvalt[2]=0;
                printf("gtypeTemp:%d\n",gvalt[0]); 
                printf("gmodeTemp:%d\n",gvalt[1]);
                printf("gvalTemp:%d\n",gvalt[2]);
                serial_Write(gvalt);
                break;
            case 4:
                gvalt[0]= gtypeTemp;
                gvalt[1]=4;
                gvalt[2]=0;
                printf("gtypeTemp:%d\n",gvalt[0]); 
                printf("gmodeTemp:%d\n",gvalt[1]);
                printf("gvalTemp:%d\n",gvalt[2]);
                serial_Write(gvalt);
                break;
            default:
                break;
        }
    }
    printf("已断开连接\n");
    
}

void message_3(cJSON *body,cJSON *pwm_ctrl)//message_type为3，控制pwm
{
    //pwm控制
    // 提取 pin_ctrl_req 对象
    //cJSON *pwm_ctrl = cJSON_GetObjectItem(body, "pwm_ctrl");
    if (!cJSON_IsObject(pwm_ctrl)) 
        {
            return;
        }
        
        cJSON *mode = cJSON_GetObjectItem(pwm_ctrl, "mode");   //mode=1 速度，mode=2 转向(unsigned char)
        cJSON *type = cJSON_GetObjectItem(pwm_ctrl, "type");
        cJSON *val =   cJSON_GetObjectItem(pwm_ctrl, "val");  //val为pwm的值 0~100(unsigned char)(unsigned char)
        gmodeTemp= mode->valueint;
        gtypeTemp=type->valueint;
        gvalTemp= val->valueint*3/4;
        gvalt[0]=gtypeTemp;
        gvalt[1]=gmodeTemp;
        gvalt[2]=gvalTemp;

        gPwmCount = 0;
        printf("gtypeTemp:%d\n",gvalt[0]); 
        printf("gmodeTemp:%d\n",gvalt[1]);
        printf("gvalTemp:%d\n",gvalt[2]);
        serial_Write(gvalt);  
}

void message_4(cJSON *body, cJSON *pin_setctrl)
{
    //cJSON *pin_setctrl = cJSON_GetObjectItem(body, "pin_setctrl");
    if (!cJSON_IsObject(pin_setctrl)) 
        {
            return;
        }
    cJSON *pin = cJSON_GetObjectItem(pin_setctrl, "pin");
    cJSON *val = cJSON_GetObjectItem(pin_setctrl, "val");  //val为pwm的值 0~100(unsigned char)(unsigned char)
    gpinTemp=pin->valueint;
    gvalTemp= val->valueint;
    gPwmCount=0;
    gvalt[0]=0;
    gvalt[1]=gpinTemp;
    gvalt[2]=gvalTemp;
    printf("gpinTemp:%d\n",gpinTemp); 
    printf("gvalTemp:%d\n",gvalTemp);
    serial_Write(gvalt);
}

void on_message(struct mosquitto *mosq, void *obj, const struct mosquitto_message *message) {
    
    time_t end = time(NULL);

    if(gStart+5>end)
    {
        printf("正在处理过期消息");
        return;
        
    }
    // 确保消息有效
    if (message->payload && message->payloadlen) 
    {
        // 将消息内容转换为字符串
        char *payload_str = (char *)malloc(message->payloadlen + 1);
        if (!payload_str) 
        {
            return;
        }
           
        memcpy(payload_str, message->payload, message->payloadlen);
        payload_str[message->payloadlen] = '\0';

        // 解析 JSON
        cJSON *json = cJSON_Parse(payload_str);
        if (json == NULL) 
        {
            fprintf(stderr, "Error before: [%s]\n", cJSON_GetErrorPtr());
        } 
        else 
        {
            // 提取 head 对象
            cJSON *head = cJSON_GetObjectItem(json, "head");
            if (!cJSON_IsObject(head)) 
            {
                return;
            }
               // 提取 message_type
            cJSON *message_type = cJSON_GetObjectItem(head, "message_type");
            if (!cJSON_IsNumber(message_type)) 
            {
                return;
            }
            cJSON *body = cJSON_GetObjectItem(json, "body");
            if (!cJSON_IsObject(body)) 
            {
                return;
            }
            cJSON *pwm_ctrl = cJSON_GetObjectItem(body, "pwm_ctrl");
            cJSON *pin_setctrl = cJSON_GetObjectItem(body, "pin_setctrl");

            if(pwm_ctrl==NULL||pin_setctrl==NULL)
            { 
                free(payload_str);
                return;
            }
            gmessage_type=message_type->valueint;
            printf("message_type: %d\n",message_type->valueint);

           
            switch(gmessage_type)
            {
                case 0:
                    message_0();
                    break;
                case 3:
                    message_3(body,pwm_ctrl);
                    break;
                case 4:
                    message_4(body,pin_setctrl);
                    break;
                default:
                    break;
            }   
        
            } 
             // 释放 payload 字符串
            free(payload_str);
                                      
    }
}

int mqtt_create(struct mosquitto *mosq) //创建mqtt客服端
{
    
    
       // 设置连接和消息回调
    mosquitto_connect_callback_set(mosq, on_connect);
    mosquitto_message_callback_set(mosq, on_message);

    //设置用户名和密码
    mosquitto_username_pw_set(mosq, USERNAME, PASSWORD);

   
    // 创建 mosquitto 客户端
    rc = mosquitto_connect(mosq, BROKER_ADDRESS, BROKER_PORT, 60);
    if (rc != MOSQ_ERR_SUCCESS) {                             
        fprintf(stderr, "Failed to connect to broker: %s\n", mosquitto_strerror(rc));
        mosquitto_destroy(mosq);
        return EXIT_FAILURE;
    }
    //mosquitto_subscribe_opt_set(mosq, TOPIC, strlen(TOPIC), 1, MOSQ_OPT_NO_LOCAL);

    
}    

int mqtt_cycle(struct mosquitto *mosq)
{

   
    //mosquitto_message_callback_set(mosq, NULL);
    // 开始循环，处理网络流量
    //mosquitto_loop_start(mosq);//后台处理
    //mosquitto_subscribe_with_options(mosq, NULL, TOPIC, 0, MQTT_SUB_OPT_NO_LOCAL);
    mosquitto_loop_forever(mosq, -1, 1); // -1 表示无限等待，1 表示处理消息的最大数量
     //mosquitto_message_retry_set(mosq, 10);
}

int mqtt_clean(struct mosquitto *mosq)
{
      // 清理
    mosquitto_destroy(mosq);
    mosquitto_lib_cleanup(); 
}